<?php

/** ensure this file is being included by a parent file */

defined('_JEXEC') or die('Restricted access');



require_once (JPATH_ADMINISTRATOR.'/components/com_k2store/library/plugins/payment.php');

require_once (JPATH_SITE.'/components/com_k2store/helpers/utilities.php');
require_once JPATH_PLUGINS.'/k2store/payment_mabna/mabnalibs/mabnalibs.php';
class plgK2StorePayment_mabna extends K2StorePaymentPlugin

{   

    /**

     * @var $_element  string  Should always correspond with the plugin's filename, 

     *                         forcing it to be unique 

     */

    var $_element    = 'payment_mabna';
    var $trans_code = '';
    

    /**

     * Constructor

     *

     * For php4 compatability we must not use the __constructor as a constructor for plugins

     * because func_get_args ( void ) returns a copy of all passed arguments NOT references.

     * This causes problems with cross-referencing necessary for the observer design pattern.

     *

     * @param object $subject The object to observe

     * @param     array  $config  An array that holds the plugin configuration

     * @since 1.5

     */

    function plgK2StorePayment_mabna(& $subject, $config) {

        parent::__construct($subject, $config);

        $this->loadLanguage( '', JPATH_ADMINISTRATOR );

    }


    /**

     * @param $data     array       form post data

     * @return string   HTML to display

     */
	private function CurrencyAmount($amount)
    {
        $currency = $this->params->get('currency');
        if ($currency) 
		{ 
            $amount *= 10;
        }
        return $amount;
    }
	
    function _prePayment( $data )
    {
        // get component params
        $params = &JComponentHelper::getParams('com_k2store');
        // prepare the payment form
        $vars = new JObject();
        $vars->order_id = $data['order_id'];
        $vars->orderpayment_id = $data['orderpayment_id'];
        $vars->orderpayment_amount = $this->CurrencyAmount($data['orderpayment_amount']);
        $vars->orderpayment_type = $this->_element;
        $vars->notify_url = JURI::root()."index.php?option=com_k2store&view=checkout&task=confirmPayment&orderpayment_type=".$this->_element."&paction=process&tmpl=component&custom=".$vars->orderpayment_id."&order_id=".$vars->order_id;
        $sahkey = $this->params->get( 'sahkey', '' );
        $html = mabnaClass::setMabna($vars->orderpayment_amount,'',$sahkey,$vars->notify_url);
		
		$vars->amount =  $vars->orderpayment_amount;
		$vars->terminal = $sahkey;
		$vars->callBackUrl = $vars->notify_url;
		$vars->invoiceNumber =time();
		$html = $this->_getLayout('prepayment', $vars);
        return $html;
    }
    
    /**
     * Processes the payment form
     * and returns HTML to be displayed to the user
     * generally with a success/failed message
     *  
     * @param $data     array       form post data
     * @return string   HTML to display
     */
    function _postPayment( $data )
    {
        // Process the payment
        $paction = JRequest::getVar('paction');
        $vars = new JObject();
        switch ($paction) 
        {
            case "display_message":
                $vars->message = JText::_('K2STORE_MABNA_MESSAGE_PAYMENT_ACCEPTED_FOR_VALIDATION');
                $html = $this->_getLayout('message', $vars);
                $html .= $this->_displayArticle();
              break;
            case "process":
                $vars->message = $this->_process();
				 $rediect = JURI::root()."index.php?option=com_k2store&view=checkout&task=confirmPayment";
				if($vars->message == '')
				{
					$html = $this->_getLayout('message', $vars);
                    $trans_code = $this->trans_code;
                    JFactory::getApplication()->redirect($rediect,"با تشکر از شما پرداخت با موفقیت انجام شد کد رهگیری: $trans_code");	
				}else
				{
					 JFactory::getApplication()->redirect($rediect,"خطا : ".$vars->message , 'error');	
				}
                
              exit;
                $app =& JFactory::getApplication();
                $app->close();
              break;
            case "cancel":
                $vars->message = JText::_( 'K2STORE_MABNA_MESSAGE_CANCEL' );
                $html = $this->_getLayout('message', $vars);
              break;
            default:
                $vars->message = JText::_( 'K2STORE_MABNA_MESSAGE_INVALID_ACTION' );
                $html = $this->_getLayout('message', $vars);
              break;
        }
        return $html;
    }   
    
    /**
     * Prepares variables for the payment form
     * 
     * @return unknown_type
     */
    function _renderForm( $data )
    {
        $user = JFactory::getUser();    
        $vars = new JObject();
        
        $html = $this->_getLayout('form', $vars);
        
        return $html;
    }
    
        /**
     * Validates the IPN data
     *
     * @param array $data
     * @return string Empty string if data is valid and an error message otherwise
     * @access protected
     */


    /************************************
     * Note to 3pd: 
     * 
     * The methods between here
     * and the next comment block are 
     * specific to this payment plugin
     * 
     ************************************/

    /**
     *
     * @return HTML
     */
    function _process() 
    {
       
       $data = $_REQUEST;// JRequest::get('post');

        // validate the IPN info
       
	    $MerchantID = $this->params->get( 'sahkey', '' );
		
        if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			 $query->select(array('COUNT(*)'))->from($db->quoteName('#__k2store_orders'))
			 ->where($db->quoteName('transaction_id') . ' LIKE '. $db->quote('%'.$_POST['digitalreceipt'].'%'));
			$db->setQuery($query);
			$results = $db->loadResult();

			if($results == 0)
			{
				 $payResult = mabnaClass::getMabna($_POST,$MerchantID); 
			}else
			{
				$payResult[0] = 0;
				$payResult[1] = 'رسید قبلا استفاده شده است';
			}
		}
		else
		{
			$payResult[0] = 0;
			$payResult[1] = $_POST['respmsg'];
		}
		  
		  
		if($payResult[0])
        {
            $data['payment_status'] = 'Completed';
        }
        else
        {
            // ipn Validation failed
            $data['ipn_validation_results'] =  $error = $payResult[1];
            $data['payment_status'] = 'Failed';
        }

        // prepare some data
        $order_id           = (int) @$data['order_id'];
        $orderpayment_id    = (int) @$data['custom'];
     
            $payment_error = '';
           $data['trans_id'] = $_POST['digitalreceipt'];
		   $this->trans_code = $payResult[1];
            $payment_error = $this->_processSale( $data, $error );

            if ($payment_error)
            {
                 // it seems like an error has occurred during the payment process
                 $error .= "\n<br/>" . $payment_error ;
            }

        if ($error) {
            // send an emails to site's administrators with error messages
            $this->_sendErrorEmails($error, $data['transaction_details']);
            return $error;
        }


        // if here, all went well
        //$error = 'processed';
        return $error;

    }
  

    

    /**

     * Processes the sale payment

     * 

     * @param array $data IPN data

     * @return boolean Did the IPN Validate?

     * @access protected

     */

    function _processSale( $data, $ipnValidationFailed='' )

    {

           /*
         * validate the payment data
         */
        $errors = array();

        if (!empty($ipnValidationFailed))
        {
            $errors[] = $ipnValidationFailed;
        }

        if (empty($data['custom']))
        {
            $errors[] = JText::_('K2STORE_MABNA_MESSAGE_INVALID_ORDERPAYMENTID');
            return count($errors) ? implode("\n", $errors) : '';
        }

        // load the orderpayment record and set some values
        JTable::addIncludePath( JPATH_ADMINISTRATOR.'/components/com_k2store/tables' );
        $orderpayment = JTable::getInstance('Orders', 'Table');

        //remove this once you are live.
        //$oid = substr($data['custom'], 2, 3);

        $orderpayment->load( $data['custom'] );
        $orderpayment->transaction_details  = $data['transaction_details'];
        $orderpayment->transaction_id       = $data['trans_id'];
        $orderpayment->transaction_status   = $data['payment_status'];

        // check the stored amount against the payment amount
        //$stored_amount = J2StoreUtilities::number( $orderpayment->get('orderpayment_amount'), array( 'thousands'=>'', 'num_decimals'=>'2', 'decimal'=>'.' ) );

        //set a default status to it
        $orderpayment->order_state = JText::_('K2STORE_PENDING'); // PENDING
        $orderpayment->order_state_id = 4; // PENDING

        // set the order's new status
        if (count($errors))
        {
            // if an error occurred
            $orderpayment->order_state = JText::_('K2STORE_FAILED'); // FAILED
            $orderpayment->order_state_id = 3; //FAILED
        }
        elseif (@$data['payment_status'] == 'Pending')
        {
            // if the transaction has the "pending" status,
            $orderpayment->order_state = JText::_('K2STORE_PENDING'); // PENDING
            $orderpayment->order_state_id = 4; //PENDING

        }
        else
        {
            $orderpayment->order_state = trim(JText::_('K2STORE_CONFIRMED')); // CONFIRMED
            $orderpayment->order_state_id = 1; //CONFIRMED
            $orderpayment->paypal_status = @$data['payment_status']; // Paypal's original status
            JLoader::register( 'K2StoreHelperCart', JPATH_SITE.'/components/com_k2store/helpers/cart.php');
            // remove items from cart
            K2StoreHelperCart::removeOrderItems( $orderpayment->id );

        }

        // save the orderpayment
        if($orderpayment->save())
        {

        } else {
            $errors[] = $orderpayment->getError();
        }

        // let us inform the user that the payment is successful
        require_once (JPATH_SITE.'/components/com_k2store/helpers/orders.php');
        K2StoreOrdersHelper::sendUserEmail($orderpayment->user_id, $orderpayment->order_id, $data['payment_status'], $orderpayment->order_state, $orderpayment->order_state_id);

        return count($errors) ? implode("\n", $errors) : '';      

    }


    /**

     * Sends error messages to site administrators

     * 

     * @param string $message

     * @param string $paymentData

     * @return boolean

     * @access protected

     */

    function _sendErrorEmails($message, $paymentData)

    {

        $mainframe =& JFactory::getApplication();
        // grab config settings for sender name and email

        $config     = &JComponentHelper::getParams('com_k2store');

        $mailfrom   = $config->get( 'emails_defaultemail', $mainframe->getCfg('mailfrom') );

        $fromname   = $config->get( 'emails_defaultname', $mainframe->getCfg('fromname') );

        $sitename   = $config->get( 'sitename', $mainframe->getCfg('sitename') );

        $siteurl    = $config->get( 'siteurl', JURI::root() );

        $recipients = $this->_getAdmins();

        $mailer =& JFactory::getMailer();
        $subject = JText::sprintf('K2STORE_MABNA_PAYMENT_NOT_VALIDATED_SUBJECT', $sitename);
        
        foreach ($recipients as $recipient) 

        {

            $mailer = JFactory::getMailer();        

            $mailer->addRecipient( $recipient->email );

        

            $mailer->setSubject( $subject );

            $mailer->setBody( JText::sprintf('K2STORE_MABNA_PAYMENT_FAILED_BODY', $recipient->name, $sitename, $siteurl, $message, $paymentData) );          

            $mailer->setSender(array( $mailfrom, $fromname ));

            $sent = $mailer->send();

        }

        return true;

    }



    /**

     * Gets admins data

     * 

     * @return array|boolean

     * @access protected 

     */

    function _getAdmins()

    {

        $db =& JFactory::getDBO();

        $query = $db->getQuery(true);

        $query->select('u.name,u.email');

        $query->from('#__users AS u');

        $query->join('LEFT', '#__user_usergroup_map AS ug ON u.id=ug.user_id');

        $query->where('u.sendEmail = 1');

        $query->where('ug.group_id = 8');

        

        $db->setQuery($query);

        $admins = $db->loadObjectList();

        if ($error = $db->getErrorMsg()) {

            JError::raiseError(500, $error);

            return false;

        }

        return $admins;               

    }

    

    

}



